%global python3_pkgversion 3.11
%global srcname h2

%global common_description %{expand:
HTTP/2 Protocol Stack This repository contains a pure-Python
implementation of a HTTP/2 protocol stack. It's written from the ground up to
be embeddable in whatever program you choose to use, ensuring that you can
speak HTTP/2 regardless of your programming paradigm.}

Name:           python-h2
Version:        4.1.0
Release:        2.ac14.py3.11%{?dist}
Summary:        HTTP/2 State-Machine based protocol implementation

License:        MIT
URL:            https://hyper-h2.readthedocs.io
VCS:            https://github.com/python-hyper/h2
Source0:        %vcs/archive/v%{version}/%{srcname}-%{version}.tar.gz
# downstream only patch
Patch0:         0001-Fedora-tox-adjustments.patch
# repr() changes in Python 3.11
Patch1:         0001-Fix-repr-checks-for-Python-3.11.patch

BuildArch:      noarch
BuildRequires:  make
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}dist(sphinx)

%description %{common_description}

%package -n     python%{python3_pkgversion}-%{srcname}
Summary:        %{summary}

%description -n python%{python3_pkgversion}-%{srcname} %{common_description}

%package doc
Summary:        Documentation for %{name}

%description doc
%{common_description}

This is the documentation package for %{name}.

%prep
%autosetup -p1 -n %{srcname}-%{version}

%generate_buildrequires
%pyproject_buildrequires -t

%build
%pyproject_wheel

# generate html docs
PYTHONPATH=$PWD/build/lib.%{python3_platform}-cpython-%{python3_version_nodots} sphinx-build-%{python3_pkgversion} docs/source html
# remove the sphinx-build-%{python3_pkgversion} leftovers
rm -rf html/.{doctrees,buildinfo}

%install
%pyproject_install
%pyproject_save_files %{srcname}

%check

for b in $(find %{buildroot}%{_bindir}/ -type f) ; do mv "$b" $(sed -re "s|(.*)$|\1-%{python3_pkgversion}|"<<<"$b"); done
for m in $(find %{buildroot}%{_mandir}/ -type f) ; do mv "$m" $(sed -re "s|(.*).([1-8])(.*)$|\1-%{python3_pkgversion}.\2\3|"<<<"$m"); done
for m in $(find %{buildroot}%{_datadir}/locale/* -type f) ; do mv "$m" $(sed -re "s|(.*).mo$|\1-%{python3_pkgversion}.mo|"<<<"$m"); done
for l in $(find %{buildroot}/usr/lib64/lib* -type f -o -type l) ; do mv "$l" $(sed -re "s|(.*).so(.*)$|\1-py%{python3_pkgversion}.so\2|"<<<"$l"); done
for p in $(find %{buildroot}/usr/lib64/pkgconfig/* -type f) ; do mv "$p" $(sed -re "s|(.*).pc$|\1-py%{python3_pkgversion}.pc|"<<<"$p"); done
%files -n python%{python3_pkgversion}-%{srcname} -f %{pyproject_files}

%files doc
%doc html
%license LICENSE

%changelog
* Thu Apr 18 2024 Ding-Yi Chen <dingyichen@gmail.com> -  4.1.0-2.ac14.py3.11
 - Cut corner packaging
